# -*- coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from __future__ import print_function
from __future__ import unicode_literals
from __future__ import absolute_import
from __future__ import division


class cached_property(object):

    def __init__(self, method):
        self._method = method
        self.__doc__ = method.__doc__

    def __get__(self, obj, objtype=None):
        if obj is None:
            return self
        else:
            value = obj.__dict__[self._method.__name__] = self._method(obj)
            return value
